﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xrm.Sdk.Metadata;
using CrmCodeGenerator.Core.Naming;

namespace CrmCodeGenerator.Core.Model
{
    public class MappingRelationshipMN
    {
        public CrmRelationshipAttribute Attribute { get; set; }

        public string DisplayName
        {
            get;
            set;
        }

        public string ForeignKey
        {
            get
            {
                return Helper.GetProperVariableName(Attribute.ToKey);
            }
        }

        public string PrivateName
        {
            get;
            set;
        }

        public string Type
        {
            get
            {
                return Helper.GetProperVariableName(Attribute.FromEntity);
            }
        }

        public static MappingRelationshipN1 Parse(ManyToManyRelationshipMetadata rel)
        {
            return new MappingRelationshipN1
            {
                Attribute = new CrmRelationshipAttribute
                {
                    //FromEntity = rel.ReferencedEntity,
                    //FromKey = rel.ReferencedAttribute,
                    //ToEntity = rel.ReferencingEntity,
                    //ToKey = rel.ReferencingAttribute,
                    IntersectingEntity = rel.IntersectEntityName
                },
                DisplayName = Helper.GetProperVariableName(rel.SchemaName),
                PrivateName = "_nn" + Helper.GetEntityPropertyPrivateName(rel.SchemaName)
            };
        }
    }
}
